var NAVTREE =
[
  [ "Houdini Engine for Unreal", "index.html", [
    [ "Houdini Engine For Unreal", "index.html#Welcome", null ],
    [ "What's New?", "index.html#WhatNew", null ],
    [ "Documentation Overview", "index.html#Unreal", null ],
    [ "Getting Started", "_getting_started.html", [
      [ "Install", "_getting_started.html#GettingStarted_Install", [
        [ "More on installing", "_getting_started.html#GettingStarted_Installing_More", null ],
        [ "Windows", "_getting_started.html#GettingStarted_Installing_Windows", null ],
        [ "macOS", "_getting_started.html#GettingStarted_Installing_Mac", null ],
        [ "Linux", "_getting_started.html#GettingStarted_Installing_Linux", null ]
      ] ],
      [ "Verify the plug-in is loaded", "_getting_started.html#GettingStarted_Verify", null ],
      [ "First Steps", "_getting_started.html#GettingStarted_FirstSteps", null ]
    ] ],
    [ "Session", "_session.html", [
      [ "Local Session", "_session.html#LocalSession", [
        [ "In Process", "_session.html#SessionInProcess", null ]
      ] ],
      [ "Remote Session", "_session.html#RemoteSession", [
        [ "TCP Socket", "_session.html#SessionSocket", null ],
        [ "Named Pipe or domain socket", "_session.html#SessionNamedPipe", null ]
      ] ],
      [ "Debugging Session", "_session.html#SessionDebugging", null ]
    ] ],
    [ "Assets", "_assets.html", [
      [ "Houdini Asset", "_assets.html#AssetsHoudiniAsset", null ],
      [ "Asset Details Panel", "_assets.html#AssetsOptions", [
        [ "Options", "_assets.html#AssetsOptionsOptions", null ],
        [ "Cooking", "_assets.html#AssetsCooking", null ],
        [ "Baking", "_assets.html#AssetsBaking", null ],
        [ "Help and Debugging", "_assets.html#AssetsHelp", null ]
      ] ]
    ] ],
    [ "Parameters", "_parameters.html", [
      [ "Integers", "_parameters.html#ParametersInt", null ],
      [ "Floats", "_parameters.html#ParametersFloat", null ],
      [ "Strings", "_parameters.html#ParametersString", null ],
      [ "Buttons", "_parameters.html#ParametersButton", null ],
      [ "Colors", "_parameters.html#ParametersColor", null ],
      [ "Files", "_parameters.html#ParametersFile", null ],
      [ "Folders", "_parameters.html#ParametersFolder", null ],
      [ "Labels", "_parameters.html#ParametersLabel", null ],
      [ "MultiParams", "_parameters.html#ParametersMulti", null ],
      [ "Ramps", "_parameters.html#ParametersRamp", null ],
      [ "Separators", "_parameters.html#ParametersSeparator", null ],
      [ "Toggle", "_parameters.html#ParametersToggle", null ],
      [ "Operator Path", "_parameters.html#ParametersOperatorPath", null ],
      [ "Menus", "_parameters.html#ParametersMenu", null ]
    ] ],
    [ "Special Attributes and Groups", "_attributes.html", [
      [ "Houdini to Unreal", "_attributes.html#AttributesInput", null ],
      [ "Unreal to Houdini", "_attributes.html#AttributesOutput", null ],
      [ "Groups", "_attributes.html#AttributesGroups", null ],
      [ "Standard Houdini Attributes", "_attributes.html#AttributesStandard", null ],
      [ "Generic UProperty Attributes", "_attributes.html#AttributesGenericUproperty", null ]
    ] ],
    [ "Inputs", "_inputs.html", [
      [ "Creating Inputs", "_inputs.html#InputCreate", [
        [ "Node Inputs", "_inputs.html#InputNode", null ],
        [ "Object Path Inputs", "_inputs.html#InputObjectPath", null ],
        [ "Setting A Default Input Type", "_inputs.html#InputDefault", null ]
      ] ],
      [ "Input Details Panel", "_inputs.html#InputDetailsPanel", [
        [ "Keep World Transform", "_inputs.html#InputsKeepWorlTransform", null ],
        [ "Pack Geometry Before Merging", "_inputs.html#InputsPackGeoBeforeMerging", null ],
        [ "Export All LODs", "_inputs.html#InputsExportAllLODs", null ]
      ] ],
      [ "Input Types", "_inputs.html#InputsTypes", [
        [ "Geometry Inputs", "_inputs.html#InputsGeo", null ],
        [ "Asset Inputs", "_inputs.html#InputsAsset", null ],
        [ "Curve Inputs", "_inputs.html#InputsCurve", null ],
        [ "Landscape Inputs", "_inputs.html#InputsLandscape", null ],
        [ "World Outliner Inputs", "_inputs.html#InputsWorld", null ]
      ] ]
    ] ],
    [ "Curves", "_curves.html", [
      [ "Houdini Curves", "_curves.html#CurvesHoudini", [
        [ "Input Curves", "_curves.html#CurvesInputs", null ],
        [ "Editable Curve Nodes", "_curves.html#CurvesEditableNodes", null ],
        [ "Editing Houdini Curves", "_curves.html#CurvesEditing", null ]
      ] ],
      [ "Unreal Spline Components", "_curves.html#CurvesUnreal", null ],
      [ "Rotation and Scale Attributes", "_curves.html#CurvesRotScale", null ]
    ] ],
    [ "Handles", "_handles.html", [
      [ "Transformer Handle", "_handles.html#HandlesTransform", null ],
      [ "Bounder Handle", "_handles.html#HandlesBounder", null ]
    ] ],
    [ "Outputs", "_outputs.html", [
      [ "Static Meshes", "_outputs.html#OutputStaticMesh", null ],
      [ "Instanced Static Meshes", "_outputs.html#OutputInstancedStaticMesh", null ],
      [ "Landscapes", "_outputs.html#OutputLandscape", null ]
    ] ],
    [ "Meshes", "_meshes.html", [
      [ "Input", "_meshes.html#MeshInput", null ],
      [ "Output", "_meshes.html#MeshOutput", [
        [ "Mesh Generation", "_meshes.html#MeshGeneration", null ],
        [ "Level of Details", "_meshes.html#MeshLODs", null ],
        [ "Materials and Attributes", "_meshes.html#MeshMatAttr", null ]
      ] ]
    ] ],
    [ "Instances", "_instancing.html", [
      [ "Output", "_instancing.html#InstancingOutput", [
        [ "Packed Primitives", "_instancing.html#InstancingPack", null ],
        [ "Object Instancers", "_instancing.html#InstancingObject", null ],
        [ "Attribute Instancers", "_instancing.html#InstancingAttributes", null ]
      ] ],
      [ "Overriding", "_instancing.html#InstancingOverriding", null ],
      [ "Variations", "_instancing.html#InstancingVariations", null ]
    ] ],
    [ "Landscapes", "_landscapes.html", [
      [ "Input", "_landscapes.html#LandscapeInput", null ],
      [ "Output", "_landscapes.html#LandscapeOutput", [
        [ "Data conversion", "_landscapes.html#LandscapeData", null ],
        [ "Landscape size", "_landscapes.html#LandscapeSize", null ],
        [ "Details Panel", "_landscapes.html#LandscapeDetials", null ]
      ] ]
    ] ],
    [ "Materials", "_materials.html", [
      [ "By Attribute", "_materials.html#MaterialsByAttribute", null ],
      [ "Generate", "_materials.html#MaterialsGenerate", null ],
      [ "Material Instances", "_materials.html#MaterialsInstances", [
        [ "Material Instance Parameters", "_materials.html#MaterialsInstancesParameter", null ]
      ] ]
    ] ],
    [ "Collisions", "_collisions.html", [
      [ "Complex Collisions", "_collisions.html#CollisionsComplex", null ],
      [ "Convex Collisions", "_collisions.html#CollisionsUCX", null ],
      [ "Simple Collisions", "_collisions.html#CollisionsSimple", null ],
      [ "Level Of Detail Collisions", "_collisions.html#CollisionsLOD", null ],
      [ "Splitting", "_collisions.html#CollisionsSplitting", null ],
      [ "Naming Conventions", "_collisions.html#CollisionsNaming", null ]
    ] ],
    [ "Mesh Sockets", "_sockets.html", [
      [ "Set up", "_sockets.html#SocketSetup", [
        [ "Using Point Groups", "_sockets.html#SocketGroups", null ],
        [ "Using Detail Attributes", "_sockets.html#SocketAttributes", null ]
      ] ],
      [ "Pre-assignement", "_sockets.html#SocketPreAssign", null ]
    ] ],
    [ "Debugging", "_debugging.html", [
      [ "Overview", "_debugging.html#DebuggingOverview", null ],
      [ "Debugging Workflows", "_debugging.html#DebuggingWorkflows", null ],
      [ "Houdini Engine Debugger", "_debugging.html#DebuggingEngineDebugger", null ]
    ] ],
    [ "Using FBX Files", "_f_b_x.html", [
      [ "Export from Houdini", "_f_b_x.html#FBXOut", null ],
      [ "Import into Unreal", "_f_b_x.html#FBXIn", null ]
    ] ],
    [ "Packaging", "_packaging.html", [
      [ "Packaging Houdini Assets", "_packaging.html#PackagingPackaging", null ],
      [ "Building Plug-in with UE4 Source", "_packaging.html#PackagingSourceBuild", null ],
      [ "Baking Outputs", "_packaging.html#PackagingBaking", null ]
    ] ],
    [ "Coordinate Systems", "_coordinate_system.html", null ],
    [ "Settings", "_settings.html", [
      [ "Session", "_settings.html#SettingSession", null ],
      [ "Instantiating", "_settings.html#SettingInstantiating", null ],
      [ "Cooking", "_settings.html#SettingCooking", null ],
      [ "Parameters", "_settings.html#SettingParameters", null ],
      [ "Collision Generation", "_settings.html#SettingCollision", null ],
      [ "Geometry Marshalling", "_settings.html#SettingMarshalling", null ],
      [ "Scaling And Import", "_settings.html#SettingImport", null ],
      [ "Generated Static Mesh Settings", "_settings.html#SettingSM", null ],
      [ "Static Mesh Build Settings", "_settings.html#SettingSMBuild", null ],
      [ "Houdini Location", "_settings.html#SettingHLocation", null ],
      [ "Plug-in Information", "_settings.html#SettingPluginInfo", null ]
    ] ],
    [ "Custom Commands", "_commands.html", [
      [ "Overview", "_commands.html#CommandsOverview", null ],
      [ "Console Commands", "_commands.html#CommandsConsole", null ],
      [ "File Menu Actions", "_commands.html#CommandsMenu", null ],
      [ "Keyboard Shortcuts", "_commands.html#CommandsShortcut", null ]
    ] ],
    [ "Houdini Engine Tools", "_houdini_tools.html", [
      [ "Houdini Tools", "_houdini_tools.html#HoudiniToolsMode", null ],
      [ "Custom Houdini Tool", "_houdini_tools.html#HoudiniToolsCustom", null ],
      [ "Default Houdini Tools", "_houdini_tools.html#HoudiniToolsDefault", null ]
    ] ],
    [ "Houdini-Niagara Plug in", "_niagara.html", [
      [ "Houdini CSV Asset", "_niagara.html#NiagaraHoudiniCSV", [
        [ "Special Attributes", "_niagara.html#SpecAttr", null ]
      ] ],
      [ "Houdini-Niagara Data Interface", "_niagara.html#NiagaraDataInterface", [
        [ "GetFloatValue", "_niagara.html#GetFloatValue", null ],
        [ "GetVectorValue", "_niagara.html#GetVectorValue", null ],
        [ "GetVectorValueEx", "_niagara.html#GetVectorValueEx", null ],
        [ "GetPosition", "_niagara.html#GetPosition", null ],
        [ "GetNormal", "_niagara.html#GetNormal", null ],
        [ "GetTime", "_niagara.html#GetTime", null ],
        [ "GetVelocity", "_niagara.html#GetVelocity", null ],
        [ "GetColor", "_niagara.html#GetColor", null ],
        [ "GetPositionAndTime", "_niagara.html#GetPositionAndTime", null ],
        [ "GetNumberOfPoints", "_niagara.html#GetNumberOfPoints", null ],
        [ "GetNumberOfRows", "_niagara.html#GetNumberOfRows", null ],
        [ "GetNumberOfColumns", "_niagara.html#GetNumberOfColumns", null ],
        [ "GetLastRowIndexAtTime", "_niagara.html#GetLastRowIndexAtTime", null ],
        [ "GetPointIDsToSpawnAtTime", "_niagara.html#GetPointIDsToSpawnAtTime", null ],
        [ "GetRowIndexesForPointAtTime", "_niagara.html#GetRowIndexesForPointAtTime", null ],
        [ "GetPointPositionAtTime", "_niagara.html#GetPointPositionAtTime", null ],
        [ "GetPointValueAtTime", "_niagara.html#GetPointValueAtTime", null ],
        [ "GetPointVectorValueAtTime", "_niagara.html#GetPointVectorValueAtTime", null ],
        [ "GetPointVectorValueAtTimeEx", "_niagara.html#GetPointVectorValueAtTimeEx", null ],
        [ "GetPointLife", "_niagara.html#GetPointLife", null ],
        [ "GetPointType", "_niagara.html#GetPointType", null ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"_assets.html"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  if (node.childrenData) {
    var imgNode = document.createElement("img");
    imgNode.style.paddingLeft=(16*level).toString()+'px';
    imgNode.width  = 16;
    imgNode.height = 22;
    imgNode.border = 0;
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    var span = document.createElement("span");
    span.style.display = 'inline-block';
    span.style.width   = 16*(level+1)+'px';
    span.style.height  = '22px';
    span.innerHTML = '&#160;';
    domNode.appendChild(span);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).css({'display':'block'});
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function removeToInsertLater(element) {
  var parentNode = element.parentNode;
  var nextSibling = element.nextSibling;
  parentNode.removeChild(element);
  return function() {
    if (nextSibling) {
      parentNode.insertBefore(element, nextSibling);
    } else {
      parentNode.appendChild(element);
    }
  };
}

function getNode(o, po)
{
  var insertFunction = removeToInsertLater(po.li);
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
  insertFunction();
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  $(window).load(function(){
    navTo(o,toroot,window.location.hash,relpath);
    showRoot();
  });

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })
}

